﻿using System.Drawing;

using DevExpress.Utils.Drawing;
using DevExpress.XtraSplashScreen;

namespace TestProject
{
    /// <summary>
    /// 커스텀 오버레이 윈도우 페인터
    /// </summary>
    public class CustomOverlayWindowPainter : OverlayWindowPainterBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 폰트
        /// </summary>
        private static readonly Font _font;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region 생성자 - CustomOverlayWindowPainter()

        /// <summary>
        /// 생성자
        /// </summary>
        static CustomOverlayWindowPainter()
        {
            _font = new Font("나눔고딕코딩", 18, FontStyle.Bold);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region 그리기 - Draw(context)

        /// <summary>
        /// 그리기
        /// </summary>
        /// <param name="context">컨텍스트</param>
        protected override void Draw(OverlayWindowCustomDrawContext context)
        {
            context.Handled = true;

            GraphicsCache cache = context.DrawArgs.Cache;

            cache.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;

            Rectangle boundRectangle = context.DrawArgs.Bounds;

            context.DrawBackground();

            string message = "잠시만 기다려 주시기 바랍니다.";

            SizeF textSize = cache.Graphics.MeasureString(message, _font);

            PointF point = new PointF
            (
                (boundRectangle.Width  - textSize.Width ) / 2,
                (boundRectangle.Height - textSize.Height) / 2
            );

            cache.Graphics.DrawString(message, _font, Brushes.Black, point);
        }

        #endregion
    }
}